/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.command;

import de.steamwar.command.dto.ExecutionIdentifier;
import de.steamwar.command.dto.TestSWCommand;
import de.steamwar.command.dto.TestTypeMapper;

import java.util.Collection;

public class NullMapperCommand extends TestSWCommand {

    public NullMapperCommand() {
        super("nullmapper");
    }

    @Register
    public void test(String sender, @AllowNull String arg) {
        if (arg == null) {
            throw new ExecutionIdentifier("null");
        }
        throw new ExecutionIdentifier("notnull");
    }

    @ClassMapper(value = String.class, local = true)
    public TestTypeMapper<String> typeMapper() {
        return new TestTypeMapper<String>() {
            @Override
            public String map(String sender, PreviousArguments previousArguments, String s) {
                if (s.equals("Hello World")) {
                    return null;
                }
                return s;
            }

            @Override
            public Collection<String> tabCompletes(String sender, PreviousArguments previousArguments, String s) {
                return null;
            }
        };
    }
}
